package tp3;
import tp3.TaskStatus;
import java.time.LocalDate;
import java.time.Period;

public class Task {
    private String idTask;
    private LocalDate creationDate;
    private LocalDate deadline;
    private TaskStatus state;
    private String description;
    private int duration;

    private static int counter = 0;

    public void Task(String description, int duration){
        this.description=description;
        this.duration=duration;
        this.creationDate=LocalDate.now();
        this.state=TaskStatus.TODO;
        this.deadline=creationDate.plusDays(duration);
        counter++;
        this.idTask= String.valueOf(LocalDate.now().getYear()).substring(String.valueOf(LocalDate.now().getYear()).length() - 2, String.valueOf(LocalDate.now().getYear()).length())
                    +String.valueOf(LocalDate.now().getMonth())  + String.valueOf(counter);
    }

    public void Task(String description, LocalDate creation, LocalDate deadline, int duration){
        this.description=description;
        this.creationDate=creation;
        this.deadline=deadline;
        this.duration=duration;
        this.state=TaskStatus.TODO;
        counter++;
        this.idTask= String.valueOf(LocalDate.now().getYear()).substring(String.valueOf(LocalDate.now().getYear()).length() - 2, String.valueOf(LocalDate.now().getYear()).length())
                    +String.valueOf(LocalDate.now().getMonth())  + String.valueOf(counter);
    }

    public String toString() {
        return "(T"+idTask+" = "+description+":"+state+"("+duration+")"+" :"+deadline;
    }

    void changeStatus(TaskStatus st){
        this.state=st;
    }

    void changeStatus(char c){
        if (c=='T'){
            this.state=TaskStatus.TODO;
        }else if (c=='O'){
            this.state=TaskStatus.ONGOING;
        }else if (c=='D'){
            this.state=TaskStatus.DELAYED;
        }else if (c=='F'){
            this.state=TaskStatus.FINISHED;
        }
    }

    void changeStatus(){
        int index=this.state.ordinal();
        this.state=TaskStatus.values()[(index+1)%TaskStatus.values().length];
    }

    boolean isLate(){
        Period period=LocalDate.now().until(this.deadline);
        if(period.isNegative()){
            return true;
        }
        return false;
    }

    void delay(int nbDays){
        this.deadline=this.deadline.plusDays(nbDays);
    }

    LocalDate getDeadline(){
        return this.deadline;
    }

    LocalDate getCreationDate(){
        return this.creationDate;
    }

    Period getDuration(){
        return this.creationDate.until(this.deadline);
    }  
}