package tp3;
import java.time.LocalDate;
import java.time.Period;
import java.util.Scanner;

public class UseLocalDate {
    
    public static String dateOfTheDay(){
        return "Today's date "+LocalDate.now();
    }

    public static LocalDate inputDate(){
        Scanner input = new Scanner(System.in);  // Create a Scanner object
        
        System.out.println("Enter day");
        int day = input.nextInt();
        if(day < 1){
            day = 1;
        }else{
            if(day > 31){
                day = 31;
            }
        }

        System.out.println("Enter month");
        int month = input.nextInt();
        if(month < 1){
            month = 1;
        }else{
            if(month > 12){
                month = 12;
            }
        }

        System.out.println("Enter year");
        int year = input.nextInt();
        if(year < 0){
            year = 0;
        }

        return LocalDate.of(year, month, day);
    }

    public static String diffDate(){
        LocalDate date1=inputDate();
        LocalDate date2=inputDate();
        Period period=date1.until(date2);
        return period.toString();
    }

    public static void main(String[] args){
        System.out.println(dateOfTheDay());
        System.out.println(inputDate().toString());
        System.out.println(diffDate());
    }
}
