package tp4;
import tp4.Person;

public class Student{
    private double[] grades;
    private Person person;

    Student(Person pers, double[] grades){
        this.person = pers;
        this.grades = grades;
    }

    Student(String forename, String name, double[] grades){
        this(forename, name);
        this.grades = grades;
    }

    private Student(String forename, String name){
        person = new Person(forename, name);
    }

    int getID() { 
        return person.getID();
    }

    String getForename(){
        return person.getForename();
    }

    String getName(){
        return person.getName();
    }
/*
    double[] getGrade(){
        return thid.grades;
    }*/

    void setName(String name){
        person.setName(name);
    }

    void setForename(String forename){
        person.setForename(forename);
    }


    double getAverage(){
        if(this.grades.length == 0) return 0.0;
        double total = 0;
        for (int notes = 0; notes < this.grades.length; notes = notes + 1) {
            total = total + this.grades[notes];
        }

        return total/this.grades.length;
    }

    public String toString(){
        String res;
        res = "Student["+getID()+":"+ getForename()+" "+getName()+" = [";
        for (int notes = 0; notes < this.grades.length; notes = notes + 1) {
            res = res + this.grades[notes]+", ";
        }

        res = res + "]]"; 

        return res;
    }


    void addGrade(double aGrade){
        double[] before = this.grades;
        double[] newGrade = new double[this.grades.length + 1];

        for (int notes = 0; notes < before.length; notes = notes + 1) {
            newGrade[notes] = before[notes];
        }

        newGrade[newGrade.length - 1] = aGrade;
    }
}