package tp7; // à adapter éventuellement selon la structure de votre projet

public enum UniversityDepartment {
    F3S(1,"Faculté des Sciences de Santé et du Sport"),
    FST(2,"Faculté des Sciences et Technologies"),
    IUT(3,"Institut Universitaire de Technologies"),
    FSJPS(4,"Faculté des Sciences Juridiques, Politiques et Sociales"),
    FSEST(5,"Faculté des Sciences Économiques, Sociales et des Territoires"),
    FH(6,"Faculté des Humanités"),
    FLCS(7,"Faculté des Langues, Cultures et Sociétés"),
    FPSEF(8,"Faculté de Psychologie, Sciences de l’Education et de la Formation");

    private String departement; 
    private int composante;

    private UniversityDepartment (int c, String d){
        this.composante=c;
        this.departement=d;
    }

    public String getLabelShort(){
        return this.name();
    }

    public String getLabelLong(){
        return this.departement;
    }

    public int getDiallingCode(){
        return this.composante;
    }

    
}
